#ifndef PREDICATS_STATIQUES_H
#define PREDICATS_STATIQUES_H

//
// Identit sur des types (utile  l'occasion  titre de no-op)
//
template <class T>
   struct static_identite {
      using type = T;
   };

//
// static_negate_predicate
//
// - on suppose que T::eval<U>::value est boolen
// - static_negate_predicate<T>::eval<U>::value est la ngation
//   logique de T::eval<U>::value
//
template <class T>
struct static_negate_predicate {
   template <class U>
      struct type : std::integral_constant<bool, !T::template type<U>::value>::value {
      };
};


#endif
