#ifndef TYPE_LIST_H
#define TYPE_LIST_H

template <class...>
   struct type_list {
   };

//
// static_head<TList>::type est le type en tte de TList
//
// Depends on: nil
//
template <class T>
   struct static_head {
      using type = T;
   };
template <class T, class ... Q>
   struct static_head<type_list<T, Q...>> {
      using type = T;
   };
template <class T>
   using static_head_t = typename static_head<T>::type;

//
// static_tail<TList>::type est la liste de types en queue de TList
//
// Depends on: nil
//
template <class T>
   struct static_tail {
      using type = T;
   };
template <class T, class ... Q>
   struct static_tail<type_list<T, Q...>> {
      using type = type_list<Q...>;
   };
template <class T>
   using static_tail_t = typename static_tail<T>::type;

#endif
