#ifndef DECORATEUR_TACHE_H
#define DECORATEUR_TACHE_H

#include "Tache.h"
#include <iosfwd>

//
// La classe decorateur<V> fait un affichage dcoratif d'identifiants
// de tches, remplaant un identifiant choisi (V dans ce cas-ci) par
// un symbole marquant l'absence de tche. Elle sert  afficher le
// fruit de l'ordonnancement statique de tches priodiques, plus bas
//
template <int V>
   class decorateur_tache
   {
      char val;
   public:
      decorateur_tache(Tache_::id_type n)
         : val{ n == V ? '*' : static_cast<char>(n + '0') }
      {
      }
      friend std::ostream& operator<<(std::ostream &os, const decorateur_tache &dec)
         { return os << dec.val; }
   };

#endif
